<?php
/*
Copyright (c) 2006, John Stevens
All rights reserved.
E-mail : john AT jstevens DOT com

Non-commercial redistribution and use, with or without modification, 
is permitted provided that the following conditions are
met:

    * Redistributions must retain the above copyright
      notice, this list of conditions and the following disclaimer.

    * The name of John Stevens may not
      be used to endorse or promote products derived from this
      software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, 
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
?>
<?php 
 
 // ###################################################################

 function get_ini_boolean($section,$name,$default=false)
 {
  global $config_ini,$default_ini ;
	
	add_diag( "get_ini_boolean $section [ $name ]" ) ;
	if ( $cfg_section = get_ini_section($section) )
	{
	 if (array_key_exists($name,$cfg_section) )
	 {
		$x = $cfg_section[$name] ;
	  add_diag( "set $name = ".yes_if_true($x) ) ;
		if (!is_bool($x)) 
		{
		 add_diag("set $name = $x") ;
		 if ($x==="auto") { $x = "$default"  ; }
		}
	  add_diag( "setx $name = ".yes_if_true($x) ) ;
	  return $x  ;
	 }
	 else
	 {
	  return get_ini_default_boolean($section,$name,$default) ;
	 }
	}
	else
	{
	 add_diag( "default $name = ".yes_if_true($default) ) ;
	 return $default ;
	}
 }
 
 // ###################################################################

 function get_ini_default_boolean($section,$name,$default=false)
 {
  global $config_ini,$default_ini ;
	
	add_diag( "get_ini_default_boolean $section [ $name ]" ) ;
	if ( $cfg_section = get_ini_default_section($section) )
	{
	 if (array_key_exists($name,$cfg_section) )
	 {
		$x = $cfg_section[$name] ;
	  add_diag( "set $name = ".yes_if_true($x) ) ;
		if (!is_bool($x)) 
		{
		 add_diag("set $name = $x") ;
		 if ($x==="auto") { $x = "$default"  ; }
		}
	  add_diag( "setx $name = ".yes_if_true($x) ) ;
	  return $x  ;
	 }
	 else
	 {
	  add_diag( "default $name = ".yes_if_true($default) ) ;
	  return $default ;
	 }
	}
	else
	{
	 add_diag( "default $name = ".yes_if_true($default) ) ;
	 return $default ;
	}
 }
 
 // ###################################################################
 
 function get_ini_keys($section)
 {
  return ( $x=(get_ini_section($section) ? array_keys($x) : array() ) ) ;
 }
 
 // ###################################################################
 
 function get_ini_array($section,$name,$default="")
 {
  return (explode(",",get_ini_string($section,$name,$default))) ;
 }
 
 // ###################################################################
 
 function get_ini_string($section,$name,$default="")
 {
  global $config_ini,$default_ini ;
	
	add_diag( "get_ini_string $section [ $name ]" ) ;
	if ( ($cfg_section = get_ini_section($section)) )
	{
	 if (array_key_exists($name,$cfg_section) )
	 {
	  add_diag( "set $name = ".$cfg_section[$name] ) ;
		$x = $cfg_section[$name] ;
		$x = ( ($x<>"auto" and $x<>"") ? $x : "$default" ) ;
	  add_diag( "set $name = $x" ) ;
	  return $x  ;
	  //return ( ($x<>"auto" and $x<>"") ? $x : "$default" )  ;
	 }
	 else
	 {
	  return get_ini_default_string($section,$name,$default) ;
	 }
	}
	else
	{
	 add_diag( "default $name = $default" ) ;
	 return "$default" ;
	}
 }
 
 // ###################################################################
 
 function get_ini_default_string($section,$name,$default="")
 {
  global $config_ini,$default_ini ;
	
	add_diag( "get_ini_default_string $section [ $name ]" ) ;
	if ( ($cfg_section = get_ini_default_section($section)) )
	{
	 if (array_key_exists($name,$cfg_section) )
	 {
	  add_diag( "set $name = ".$cfg_section[$name] ) ;
		$x = $cfg_section[$name] ;
		$x = ( ($x<>"auto" and $x<>"") ? $x : "$default" ) ;
	  add_diag( "set $name = $x" ) ;
	  return $x  ;
	  //return ( ($x<>"auto" and $x<>"") ? $x : "$default" )  ;
	 }
	 else
	 {
	  add_diag( "default $name = $default" ) ;
	  return "$default" ;
	 }
	}
	else
	{
	 add_diag( "default $name = $default" ) ;
	 return "$default" ;
	}
 }
 
 // ###################################################################
 
 function get_ini_section($section)
 {
  global $config_ini,$default_ini ;
  
	// If section is missing attempt to get it from the default
	if ( array_key_exists($section,$config_ini) ) 
	{
	 add_diag( "found section $section in config.ini ".count($config_ini[$section]) ) ; //print_r($config_ini[$section]) ;
	 if ( count($config_ini[$section]) ) { return $config_ini[$section] ; }
	 else                                { return get_ini_default_section($section) ; }
	}
	else
	{
	 add_diag( "missing section $section in config.ini" ) ;
	 return get_ini_default_section($section) ;
	}	
 }
 
 // ###################################################################
 
 function get_ini_default_section($section)
 {
  global $config_ini,$default_ini ;
  
	// If section is missing attempt to get it from the default
	if ( array_key_exists($section,$default_ini) ) 
	{
	 add_diag( "found section $section in default.ini" ) ; //print_r($config_ini) ;
	 return $default_ini[$section] ;
	}
	else
	{
	 return false ;
	}	
 }
 
 // ###################################################################
 
 function set_ini_section_default($section,$default)
 {
  global $config_ini,$default_ini ;
  
	// If section is missing attempt to create it from the default section
	if ( ! array_key_exists($section,$config_ini) ) 
	{
	 if ( array_key_exists($default,$config_ini) )
	 {
	  $config_ini[$section] = $config_ini[$default] ;	  	 
	 }
	}	
	
	// If section is missing attempt to create it from the default section
	if ( ! array_key_exists($section,$default_ini) ) 
	{
	 if ( array_key_exists($default,$default_ini) )
	 {
	  $default_ini[$section] = $default_ini[$default] ;	  	 
	 }
	}	
	
 }

 // ###################################################################
 
 function win_compliant($string)
 {
	//$string = preg_replace('/:/', '#', $string); 
 	$string = preg_replace('/[^a-z0-9.{}()%$@~!+=&,;\'\^\[\]\#\- _]+/i', ' ', $string) ;
	$string = preg_replace('/\s+/', ' ', $string); 
	return $string ;
 }
 
 function is_checked($value)
 {
  if ($value) { return "checked='checked'" ; }
	return "" ;
 }

function is_true($value,$valTrue="True",$valFalse="False")
{
 if ($value) { return "$valTrue" ; }
 else        { return "$valFalse" ; }
}

function is_selected($value)
{
 if ($value) { return "selected='selected'" ; }
 else        { return "" ; }
}

function get_ftp_stat($servername) 
{
 global $FTPaddress,$FTPport,$FTPuser,$FTPpw ;
 global $TFhdd, $is_ftpdtopfield, $isftpdtopfield_pre069 ;
 
 if ( version_compare(phpversion(),"5.0.0")>=0 )
 {
  if($ftp=ftp_connect($FTPaddress[$servername],$FTPport[$servername]))
  {
   if(ftp_login($ftp,$FTPuser[$servername],$FTPpw[$servername]))
   { 
	ftp_chdir($ftp,"/") ;
    $rows = ftp_raw($ftp,"STAT") ;
    foreach($rows as $key => $line)
    {
     //echo "$servername $key = $line\n" ;
     $line = trim($line) ;
     if(substr($line,0,3)=="500") {}  // This ftp server does not understand STAT
     if(substr($line,0,3)=="211") {}  // This ftp server does understand STAT
     if(substr($line,0,20)=="ftpd (Topfield ftpd)") 
     {
	    $FTPversion[$servername]=substr($line,21) ; 
	    $is_ftpdtopfield[$servername]=true ; 
	    $is_ftpdtopfield_pre069[$servername]=(version_compare($FTPversion[$servername],"0.6.9")<0) ; 
     }  // ftpd-topfield version
     if(substr($line,0,9)=="HDD Free ") {}  // HDD freespace
     if(substr($line,0,9)=="HDD Total") { $TFhdd[$servername] = substr($line,11,9)*1024 ; }  // HDD total size
     if($line == "Unable to get HDD size info" ) 
     {
      //$server_error[$servername] = $FTPaddress[$servername]." cannot connect to Topfield PVR!" ;
      //$use_cache[$servername] = true ;
     }
    }
   }
   ftp_quit($ftp) ;
  }
 }
}

function tf_request_channel($servername,$value)
{
	global $TFuseLCN,$lcn_chn_trans ;
	
	  if($TFuseLCN[$servername])
	  {
	  	return "".array_search($value,$lcn_chn_trans)."" ;
	  }
	  else
	  {
		return "$value" ;
	  }
}

?>